aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorVratko Polak <vrpolak@cisco.com>2020-03-02 17:26:19 +0100
committerVratko Polak <vrpolak@cisco.com>2020-03-02 17:26:19 +0100
commitdaafac3521f8f7ce815b4d258f9c8c42796b0091 (patch)
tree9ad7aa20cef4cae082db172d37ad39ef3055942d
parent4a9ea7c647264779f7919a77fab042a21c312450 (diff)
Backport tox checkers from master
Change-Id: Ide532cd216b6b8026f9a803b1801b77c471f17b0 Signed-off-by: Vratko Polak <vrpolak@cisco.com>
-rw-r--r--resources/libraries/bash/entry/check/autogen.sh7
-rw-r--r--resources/libraries/bash/entry/check/copyright_year.sh70
-rw-r--r--resources/libraries/bash/entry/check/doc_verify.sh57
-rw-r--r--resources/libraries/bash/entry/check/new_line.sh4
-rw-r--r--resources/libraries/bash/entry/check/tc_naming.sh10
-rw-r--r--tox.ini47
6 files changed, 169 insertions, 26 deletions
diff --git a/resources/libraries/bash/entry/check/autogen.sh b/resources/libraries/bash/entry/check/autogen.sh
index 0164b65962..686d9d7566 100644
--- a/resources/libraries/bash/entry/check/autogen.sh
+++ b/resources/libraries/bash/entry/check/autogen.sh
@@ -1,4 +1,4 @@
-# Copyright (c) 2019 Cisco and/or its affiliates.
+# Copyright (c) 2020 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
@@ -50,10 +50,11 @@ cp -rf "${CSIT_DIR}/tests"/* "${GENERATED_DIR}/tests_tmp"/
# I think archiving the diff is enough.
diff_cmd=("diff" "-dur" "${GENERATED_DIR}/tests_tmp" "${GENERATED_DIR}/tests")
-lines="$("${diff_cmd[@]}" | tee "autogen.log" | wc -l)" || die
+# Diff returns RC=1 if output is nonzero, so we do not die on the next line.
+lines="$("${diff_cmd[@]}" | tee "autogen.log" | wc -l)"
if [ "${lines}" != "0" ]; then
# TODO: Decide which text goes to stdout and which to stderr.
- warn "Autogen conflict diff nonzero lines: ${lines}"
+ warn "Autogen conflict, diff sees nonzero lines: ${lines}"
# TODO: Disable if output size does more harm than good.
cat "autogen.log" >&2
warn
diff --git a/resources/libraries/bash/entry/check/copyright_year.sh b/resources/libraries/bash/entry/check/copyright_year.sh
new file mode 100644
index 0000000000..66667b96ca
--- /dev/null
+++ b/resources/libraries/bash/entry/check/copyright_year.sh
@@ -0,0 +1,70 @@
+# Copyright (c) 2020 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -exuo pipefail
+
+# This file should be executed from tox, as the assumed working directory
+# is different from where this file is located.
+# This file does not have executable flag nor shebang,
+# to dissuade non-tox callers.
+
+# This script runs a few grep-based command and fails
+# if it detects any file edited or added since HEAD~
+# containing a copyright notice in first 3 lines,
+# but not the current year (in the same line).
+# The offending lines are stored to copyright_year.log (overwriting).
+#
+# 3 lines were chosen, because first two lines could be shebang and empty line,
+# and more than 3 lines would start failing on files with multiple copyright
+# holders. There, only the last updating entity needs to bump its year,
+# and put other copyright lines below.
+
+# "set -eu" handles failures from the following two lines.
+BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+ echo "Source failed." >&2
+ exit 1
+}
+
+year=$(date +'%Y')
+IFS=$'\n'
+files=($(git diff --name-only HEAD~ || true))
+unset IFS
+truncate -s 0 "copyright_year.log" || die
+# A change can have thousands of files, supress console output in the cycle.
+set +x
+for fil in "${files[@]}"; do
+ # Greps do "fail" on 0 line output, we need to ignore that
+ # as 0 lines is good. We need both set +e to ensure everything executes,
+ # and || true later to avoid dying on zero.
+ piped_command="set +ex; head -n 3 '${fil}' | fgrep -i 'Copyright'"
+ piped_command+=" | fgrep -v '${year}' | awk '{print \"${fil}: \" \$0}'"
+ piped_command+=" >> 'copyright_year.log'"
+ wrong_strings="$(bash -c "${piped_command}" || true)" || die
+done
+set -x
+lines="$(< "copyright_year.log" wc -l)"
+if [ "${lines}" != "0" ]; then
+ # TODO: Decide which text goes to stdout and which to stderr.
+ warn "Copyright lines with wrong year detected: ${lines}"
+ # TODO: Disable when output size does more harm than good.
+ pwd
+ cat "copyright_year.log" >&2
+ warn
+ warn "Copyright year checker: FAIL"
+ exit 1
+fi
+
+warn
+warn "Copyright year checker: PASS"
diff --git a/resources/libraries/bash/entry/check/doc_verify.sh b/resources/libraries/bash/entry/check/doc_verify.sh
new file mode 100644
index 0000000000..5ab67909df
--- /dev/null
+++ b/resources/libraries/bash/entry/check/doc_verify.sh
@@ -0,0 +1,57 @@
+# Copyright (c) 2020 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -xeuo pipefail
+
+# This file should be executed from tox, as the assumend working directory
+# is different from where this file is located.
+# This file does not have executable flag nor shebang,
+# to dissuade non-tox callers.
+
+# "set -eu" handles failures from the following two lines.
+BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+ echo "Source failed." >&2
+ exit 1
+}
+
+common_dirs || die
+log_file="$(pwd)/doc_verify.log" || die
+
+# Pre-cleanup.
+rm -f "${log_file}" || die
+rm -f "${DOC_GEN_DIR}/csit.docs.tar.gz" || die
+rm -rf "${DOC_GEN_DIR}/_build" || die
+
+# Documentation generation.
+# Here we do store only stderr to file while stdout (inlcuding Xtrace) is
+# printed to console. This way we can track increased errors in future.
+# We do not need to do trap as the env will be closed after tox finished the
+# task.
+exec 3>&1 || die
+export BASH_XTRACEFD="3" || die
+
+pushd "${DOC_GEN_DIR}" || die
+source ./run_doc.sh ${GERRIT_BRANCH:-local} 2> ${log_file} || true
+popd || die
+
+if [[ ! -f "${log_file}" ]] || [[ -s "${log_file}" ]]; then
+ # Output file not exists or is non empty.
+ warn
+ warn "Doc verify checker: FAIL"
+ exit 1
+fi
+
+warn
+warn "Doc verify checker: PASS"
diff --git a/resources/libraries/bash/entry/check/new_line.sh b/resources/libraries/bash/entry/check/new_line.sh
index 49c3d65815..2e24c0256b 100644
--- a/resources/libraries/bash/entry/check/new_line.sh
+++ b/resources/libraries/bash/entry/check/new_line.sh
@@ -1,4 +1,4 @@
-# Copyright (c) 2019 Cisco and/or its affiliates.
+# Copyright (c) 2020 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
@@ -13,7 +13,7 @@
set -exuo pipefail
-# This file should be executed from tox, as the assumend working directory
+# This file should be executed from tox, as the assumed working directory
# is different from where this file is located.
# This file does not have executable flag nor shebang,
# to dissuade non-tox callers.
diff --git a/resources/libraries/bash/entry/check/tc_naming.sh b/resources/libraries/bash/entry/check/tc_naming.sh
index b193cfad5e..a8e90516b4 100644
--- a/resources/libraries/bash/entry/check/tc_naming.sh
+++ b/resources/libraries/bash/entry/check/tc_naming.sh
@@ -1,6 +1,4 @@
-#!/usr/bin/env bash
-
-# Copyright (c) 2019 Cisco and/or its affiliates.
+# Copyright (c) 2020 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
@@ -66,7 +64,7 @@ r_testc_rules=(
#'(ipsec[[:digit:]]+tnlhw|ipsec[[:digit:]]+tnlsw|'
#'srhip6|tcp|udp|lispip6|lispip4|vxlan){0,1}'
#'(http){0,1}-'
- '(.*)-(dev|ndrpdr|cps|rps|reconf)$'
+ '(.*)-(dev|ndrpdr|bps|cps|rps|reconf)$'
)
s_suite_rules=(
'number of SUT nodes'
@@ -85,7 +83,7 @@ r_suite_rules=(
#'(ipsec[[:digit:]]+tnlhw|ipsec[[:digit:]]+tnlsw|'
#'srhip6|tcp|udp|lispip6|lispip4|vxlan){0,1}'
#'(http){0,1}-'
- '(.*)-(dev|ndrpdr|cps|rps|reconf)$'
+ '(.*)-(dev|ndrpdr|bps|cps|rps|reconf)$'
)
rm -f "tc_naming.log" || die
@@ -139,4 +137,4 @@ if [ $((total_failed_tc + total_failed_su)) != "0" ]; then
fi
warn
-warn "Testcase naming checker: PASS" \ No newline at end of file
+warn "Testcase naming checker: PASS"
diff --git a/tox.ini b/tox.ini
index fd0a6cf8cd..8a81482119 100644
--- a/tox.ini
+++ b/tox.ini
@@ -1,4 +1,4 @@
-# Copyright (c) 2019 Cisco and/or its affiliates.
+# Copyright (c) 2020 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
@@ -25,7 +25,10 @@
# will execute only checks defined in "pylint" tox environment.
[tox]
-envlist = new_line_length, line_length, autogen, pylint, tc_naming, tc_coverage
+# Fast and brief checkers to front, slow or verbose checkers to back.
+envlist = tc_naming, tc_coverage, copyright_year, new_line_length, line_length,
+ autogen, pylint, doc_verify
+
# The following is needed as tox requires setup.py by default.
skipsdist = true
# Just a shorthand to avoid long lines.
@@ -33,16 +36,22 @@ checker_dir = ./resources/libraries/bash/entry/check
# TODO: Tox prints various warnings. Figure them out and fix them.
-[testenv:pylint]
-deps =
- pylint==1.5.4
- -r ./requirements.txt
+# Keep testenvs sorted alphabetically, please.
+
+[testenv:autogen]
whitelist_externals = /bin/bash
setenv = PYTHONPATH = {toxinidir}
-# Run pylint, but hide its return value until python warnings are cleared.
-commands = bash -c "bash {[tox]checker_dir}/pylint.sh || true"
+commands = bash {[tox]checker_dir}/autogen.sh
-# TODO: See FIXME in https://gerrit.fd.io/r/16423
+[testenv:copyright_year]
+whitelist_externals = /bin/bash
+setenv = PYTHONPATH = {toxinidir}
+commands = bash {[tox]checker_dir}/copyright_year.sh
+
+[testenv:doc_verify]
+# Fix all documentaion error before enabling voting.
+whitelist_externals = /bin/bash
+commands = bash -c "bash {[tox]checker_dir}/doc_verify.sh || true"
[testenv:line_length]
whitelist_externals = /bin/bash
@@ -56,21 +65,29 @@ whitelist_externals = /bin/bash
# the checker has to remain non-voting.
commands = bash -c "bash {[tox]checker_dir}/new_line.sh || true"
-[testenv:autogen]
+[testenv:pylint]
+basepython = python2
+deps =
+ pylint==1.5.4
+ -r ./requirements.txt
whitelist_externals = /bin/bash
setenv = PYTHONPATH = {toxinidir}
-commands = bash {[tox]checker_dir}/autogen.sh
+# Run pylint, but hide its return value until python warnings are cleared.
+commands = bash -c "bash {[tox]checker_dir}/pylint.sh || true"
-[testenv:tc_naming]
-whitelist_externals = /bin/bash
-# Fix all TC namings and remove the " || true" workaround.
-commands = bash -c "bash {[tox]checker_dir}/tc_naming.sh || true"
+# TODO: See FIXME in https://gerrit.fd.io/r/16423
[testenv:tc_coverage]
whitelist_externals = /bin/bash
# Coverage is not needed to be voting.
commands = bash -c "bash {[tox]checker_dir}/tc_coverage.sh || true"
+[testenv:tc_naming]
+whitelist_externals = /bin/bash
+commands = bash {[tox]checker_dir}/tc_naming.sh
+
+# Keep testenvs sorted alphabetically, please.
+
# TODO: Migrate current docs check here.
# TODO: Create voting "pylint violations should not increase" checker.
# TODO: Create voting checker to reject suites with Force Tags of other suite.